#!/usr/bin/perl


=pod

Pssst.. before you continue, if you don't know perl
then editing this file in any way would be very 
ver very very very very very very very stupid.

now ya know.

#################################################
#                                               #
# Roach Log Raper 1.2                           #
# Carracho Log Analyzer                         #
# Phil Hilton                                   #
# riscit@bungie.org                             #
#                                               #
#################################################
#                                               #
# Latest Version & Instructions:                #
# http://riscit.bungie.org/software/arlo.html   #
#                                               #
# If you don't understand these intructions,    #
# then you shouldn't be running a server anyway #
#                                               #
# put me into the same directory as the logs    #
# chmod 755 me                                  #
# then run me from the same directory.          #
#                                               #
# Copyright 2001 - Phil Hilton                  #
# Comments to riscit@bungie.org                 #
# This can be distributed freely, but not sold  #
#                                               #
# Payment? eh.. Whatever. How's $5?             #
# If you want to, send something to:            #
#                                               #
# Phil Hilton                                   #
# 116 Quebec Street                             #
# Farmington, ME 04938                          #
# USA                                           #
#                                               #
# A little cash would definitely help me get    #
# through college.                              #
#                                               #
# Send feature requests to riscit@bungie.org    #
#                                               #
#################################################

Change log:

1.2 
	Non-Interactive mode.... Lots and lots of command line options

1.1

	Clear screen between actions
	Clear screen on quit.
	Prompt for username if requesting user specific info and none is chosen.
	Provide count of nicknames
	"Press Return Key To Continue" prompt now accepts any key.
	
1.0

	initial release

=cut


# alas... I finally resort to outside modules...
use Getopt::Long;

my $printFullReport = '';
my $useHTML = '';
my $headerFile = '';
my $footerFile = '';
my $uploadLog = 'Uploads';
my $downloadLog = 'Downloads';
my $topX = 10;
my $BR = "\n";

# grab out command line args
# quit if they aren't kosher
exit 1 unless ( GetOptions (	
			
			'quiet|q'		=> \$beQuiet,
			
			'user|u=s'		=> \$userToCheck,
			'allusers'		=> \$allUsers,
			'topx=i'		=> \$topX,
			'noheaders'		=> \$noHeaders,
			'macbr'			=> \$useMacLineBreaks,
			
			'fullreport'	=> \$printFullReport,
			'stats'			=> \$printStats,
			'serverstats'	=> \$printServerStats,
			'leechbyratio'	=> \$printLeechRatingsByRatio,
			'leechbyuser'	=> \$printLeechRatingsByUser,
			'nicks'			=> \$printNicks,
			'downloads'		=> \$printUsersDownloads,
			'uploads'		=> \$printUsersUploads,
			'bestleech'		=> \$printBestLeechRatios,
			'worstleech'	=> \$printWorstLeechRatios,
			'topdownloaders'=> \$printTopDownloaders,
			'topuploaders'	=> \$printTopUploaders,
			'topdownloads'	=> \$printTopDownloads,
			
#			'htmlpage'		=> \$buildHTMLPage,
#			'html'			=> \$useHTML,
			
			'footerfile=s'	=> \$footerFile,
			'headerfile=s'	=> \$headerFile,
			'uploadlog|uploadslog=s'		=> \$uploadLog,
			'downloadlog|downloadslog=s'	=> \$downloadLog,
			
			) );

# change the line break char to \r if -macbr was used.
if ($useMacLineBreaks) {
	$BR="\r";
}


# set it up for all users if -allusers is an arg.
if ($allUsers) {
	$selectAllUsers = 1;
	$userToCheck = 'lookatalltheusersihopenoonehasthisasaloginnameortheyarescreweddamnitalltohell';
}


ReadLogs();

# print the header file if one was specified.
PrintFile($headerFile);


# assume we're in ineractive mode unless proven otherwise
$nonInterMode = '';

# look for noninteractive options and do them
NonInteractiveOptions();

# print the footer file (if specified) and quit 
# now if we're not going to the menu
PrintFile($footerFile) if ($nonInterMode);
exit 1 if ($nonInterMode);



# if we're here, we aren't in non-interactive mode, 
# and we can't have "all users" selected.
if ($userToCheck eq 'lookatalltheusersihopenoonehasthisasaloginnameortheyarescreweddamnitalltohell') {
	$userToCheck = '';
}

while (1) {

	print qq|
	------------------------------------------
	Please Choose:
	------------------------------------------
	1.  Select User (Current: |, ($userToCheck eq '' ? "None Selected" : $userToCheck), qq|)
	2.  General Stats For User
	3.  Nicknames For User
	4.  Uploads By User
	5.  Downloads By User
	------------------------------------------
	6.  Print All Leech Ratios Sorted By Ratio
	7.  Print All Leech Ratios Sorted By User
	8.  Servers Wide Stats
	9.  Search For File Uploaders
	10. Search For File Downloaders
	------------------------------------------
	Q. Quit
	------------------------------------------
	
	Choice: |;
	
	$x = <STDIN>;
	chop $x;
	
	ClearScreen();
	
	# if they want user specific stats, make sure a username is
	# chosen. Prompt before continuing if there isn't.
	if ( ( ($x > 1) && ($x < 6) ) && ($userToCheck eq '') ) {
		print "$BR$BREnter A Username: ";
		$userToCheck = <STDIN>;
		chop $userToCheck;
	}
	
	
	if ( ($x eq 'q') or ($x eq 'Q') ) {
		
		PrintFile($footerFile);
		
		ClearScreen();
		exit;
	
	} elsif ($x eq '10') {
	
		SearchForFileDownloader();
		
		ConfirmToContinue();
		ClearScreen();
	
	} elsif ($x eq '9') {
		
		SearchForFileUploader();
		
		ConfirmToContinue();
		ClearScreen();
		
	} elsif ($x eq '8') {
	
		PrintServerWideStats();
		
		ConfirmToContinue();
		ClearScreen();
		
	} elsif ($x eq '7') {
	
		PrintLeechRatiosSortedByUser();
		
		ConfirmToContinue();
		ClearScreen();
		
	} elsif ($x eq '6') {
	
		PrintLeechRatiosSortedByRatio();
		
		ConfirmToContinue();
		ClearScreen();
		
	} elsif ($x eq '5') {
	
		PrintFilesDownloadedBy($userToCheck);
		
		ConfirmToContinue();
		ClearScreen();
		
	} elsif ($x eq '4') {
	
		PrintFilesUploadedBy($userToCheck);
		
		ConfirmToContinue();
		ClearScreen();
		
	} elsif ($x eq '3') {
	
		PrintNicksUsedBy($userToCheck);
		
		ConfirmToContinue();
		ClearScreen();
		
	} elsif ($x eq '2') {
	
		PrintGeneralStatsFor($userToCheck);
		
		ConfirmToContinue();
		ClearScreen();
		
	} elsif ($x eq '1') {
	
		print "Enter Username: ";

		$userToCheck = <STDIN>;
		chop $userToCheck;
		
		ClearScreen();

	
	} elsif ($x eq '') {

		ClearScreen();
		
	}
	
}



###############################################################

sub PrintFilesUploadedBy {

	my ($user) = @_;
	
	print "Files Uploaded By '$user':$BR-----------------------------------$BR"
		unless ($noHeaders);
	
	foreach $fileuploaded ( keys %{ $ulsByUser{$user} } ) {
		print "$fileuploaded$BR";
	}
}

###############################################################

sub PrintFilesDownloadedBy {

	my ($user) = @_;

	print "Files Downloaded By '$user':$BR-----------------------------------$BR"
		unless ($noHeaders);

	foreach $filedownloaded ( keys %{ $dlsByUser{$user} } ) {
		print "$filedownloaded$BR";
	}

}

###############################################################

sub PrintLeechRatiosSortedByRatio {
	
	my $user;
	
	
	# HTML formatted
	
	if ($useHTML or $buildHTMLPage) {
	
		print qq|<TABLE BORDER="1" CELLSPACING="1" CELLPADDING="3"><TR><TD COLSPAN="4"><B>Leech Rating Sorted By Ratio</B></TD></TR><TR><TD><B>#</B></TD><TD><B>User</B></TD><TD><B>Bar Graph</B></TD><TD><B>Leech Rating</B></TD></TR>|;
		
		my $count = 1;
		foreach $user (sort { 
							$leechRatesByUser{$a} <=> $leechRatesByUser{$b} 
								||
							$dlCountByUser{$a} <=> $dlCountByUser{$b}
						} keys %leechRatesByUser) {
			my $barGraph = HTMLBarGraph('#0000FF', '30', '200', $leechRatesByUser{$user});		
				
			print qq|<TR><TD>|, $count++, qq|.</TD><TD>$user</TD><TD>$barGraph</TD><TD>$leechRatesByUser{$user}%</TD></TR>|;
		}
		
		print "</TABLE>";
		
		return 0;
	}	

	# normal output
	
	print "Leech Ratios Sorted By Ratio:$BR-----------------------------$BR"
		unless ($noHeaders);
	
	my $count = 1;
	foreach $user (sort { 
						$leechRatesByUser{$a} <=> $leechRatesByUser{$b} 
							||
						$dlCountByUser{$a} <=> $dlCountByUser{$b}
					} keys %leechRatesByUser) {
		print $count++, ". '$user'\t$leechRatesByUser{$user}%$BR";
	}
}

###############################################################

sub PrintLeechRatiosSortedByUser {
	
	my $user;
	
	print "Leech Ratios Sorted By User:$BR----------------------------$BR"
		unless ($noHeaders);
	
	my $count = 1;
	foreach $user (sort keys %leechRatesByUser) {
		print $count++, ". $user\t$leechRatesByUser{$user}%$BR";
	}
}

###############################################################

sub PrintNicksUsedBy {
	
	my ($user) = @_;
	
	my $nickCount = 0;
	foreach $nickUsed ( sort keys %{ $nicksByUser{$user} } ) {
		$nickCount++;
	}
	
	print "$nickCount Nicknames Used By '$user':$BR-----------------------------------$BR"
		unless ($noHeaders);
		
	foreach $nickUsed ( sort keys %{ $nicksByUser{$user} } ) {
		print "$nickUsed$BR";
	}

}

###############################################################

sub PrintGeneralStatsFor {

	my ($user) = @_; 

	print "$user\'s upload count: $ulCountByUser{$user}, download count: $dlCountByUser{$user}, leech rating: ", sprintf("%.2f",$leechRatesByUser{$user}), "\%$BR";

}

###############################################################

sub PrintServerWideStats {

	print "Server Wide upload count: $serverStats{'Upload Count'}, download count: $serverStats{'Download Count'}, leech rating: ", sprintf("%.2f", $serverStats{'Leach Ratio'}), "\%$BR$BR";
	
	PrintTopXDownloads();
	print "$BR$BR";
	PrintTopXUploaders();
	print "$BR$BR";
	PrintTopXDownloaders();
	print "$BR$BR";
	PrintWorstXLeechRatios();
	print "$BR$BR";
	PrintBestXLeechRatios();
}

###############################################################

sub PrintTopXDownloads {
	print "Top $topX Downloads:$BR-----------------$BR" unless ($noHeaders);
	
	my $count = 1;
	foreach $file (sort { $dlCountByFile{$b} <=> $dlCountByFile{$a} } keys %dlCountByFile) {
		print $count++, ". '$file'\t$dlCountByFile{$file}$BR";
		last if ($count > $topX);
	}
}

###############################################################

sub PrintTopXUploaders {

	print "Top $topX Uploaders:$BR-------------------$BR" unless ($noHeaders);
	
	my $count = 1;
	foreach $user (sort { $ulCountByUser{$b} <=> $ulCountByUser{$a} } keys %ulCountByUser) {
		print $count++, ". '$user'\t$ulCountByUser{$user}$BR";
		last if ($count > $topX);
	}
}

###############################################################

sub PrintTopXDownloaders {
	print "Top $topX Downloaders:$BR--------------------$BR" unless ($noHeaders);
	
	my $count = 1;
	foreach $user (sort { $dlCountByUser{$b} <=> $dlCountByUser{$a} } keys %dlCountByUser) {
		print $count++, ". '$user'\t$dlCountByUser{$user}$BR";
		last if ($count > $topX);
	}
}

###############################################################

sub PrintWorstXLeechRatios {
	print "Worst $topX Leech Ratios:$BR----------------------$BR" unless ($noHeaders);
	
	my $count = 1;
	foreach $user (sort { 
						$leechRatesByUser{$b} <=> $leechRatesByUser{$a} 
							||
						$dlCountByUser{$b} <=> $dlCountByUser{$a}
					} keys %leechRatesByUser) {
		print $count++, ". '$user'\t$leechRatesByUser{$user}%",  ($leechRatesByUser{$user} eq '100.00' ? " ($dlCountByUser{$user} dls)$BR" : "$BR") ;
		last if ($count > $topX);
	}
}

###############################################################

sub PrintBestXLeechRatios {

	print "Best $topX Leech Ratios:$BR---------------------$BR" unless ($noHeaders);
	
	my $count = 1;
	foreach $user (sort { 
						$leechRatesByUser{$a} <=> $leechRatesByUser{$b} 
							||
						$ulCountByUser{$a} <=> $ulCountByUser{$b}
					} keys %leechRatesByUser) {
		print $count++, ". '$user'\t$leechRatesByUser{$user}%$BR";
		last if ($count > $topX);
	}

}

###############################################################

sub SearchForFileUploader {

	print "Search For: ";
	
	my $query = '';
	
	while ($query eq '') {
		$query = <STDIN>;
		chop $query;
	}

	$originalQuery = $query;
	$query = uc $query;
	
	my @results = ();
	
	foreach $user (keys %ulsByUser) {
		
		foreach $file ( keys %{ $ulsByUser{$user} } ) {
		
			my $ucFile = uc $file;
		
			if ( $ucFile =~ /$query/ ) {
				push (@results, "'$file' - '$user' - '$ulsByUser{$user}{$file}'$BR");
			}
		}
	}
	
	if (! @results ) {
		print "No match.$BR$BR";
		return 0;
	}
	
	print "
Search For File Uploaders (Query: '$originalQuery')
'Filename' - 'User' - 'Timestamp'
--------------------------------------------------------------$BR" unless ($noHeaders);
	foreach $line (sort @results) {
		print $line;
	}
	print "$BR";
}

###############################################################


sub SearchForFileDownloader {

	print "Search For: ";
	
	my $query = '';
	
	while ($query eq '') {
		$query = <STDIN>;
		chop $query;
	}

	$originalQuery = $query;
	$query = uc $query;
	
	my @results = ();
	
	foreach $user (keys %dlsByUser) {
		
		foreach $file ( keys %{ $dlsByUser{$user} } ) {
		
			my $ucFile = uc $file;
		
			if ( $ucFile =~ /$query/ ) {
				push (@results, "'$file' - '$user' - '$dlsByUser{$user}{$file}'$BR");
			}
		}
	}
	
	if (! @results ) {
		print "No match.$BR$BR";
		return 0;
	}
	
	print "
Search For File Downloaders (Query: '$originalQuery')
'Filename' - 'User' - 'Timestamp'
--------------------------------------------------------------$BR" 
	unless ($noHeaders);
	
	foreach $line (sort @results) {
		print $line;
	}
	print "$BR";
}

###############################################################

sub ReadLogs {

	print "Reading Logs... (This may take a minute.)$BR" unless ($beQuiet);

	# account for mac line breaks in log files.
	$/ = "\r";
	
	open (UPLOADS, "<$uploadLog") || die "$BR$BR$BR\tError: Can't open upload log ('$uploadLog').";
	@uploads = <UPLOADS>;
	close (UPLOADS);

	open (DOWNLOADS, "<$downloadLog") || die "$BR$BR$BR\tError: Can't open download log ('$downloadLog').";
	@downloads = <DOWNLOADS>;
	close (DOWNLOADS);
	
	# get back to real line breaks. DEATH TO \r!!!
	$/ = "$BR";
	

	foreach $line (@uploads) {
		my ($timestamp, $ip, $user, $nick, $file) = split(/\t/, $line);
		chop $file;
	
		# weird bug workaround
		next if ($user eq '');
	
		$ulsByUser{$user}{$file} = $timestamp;
		$nicksByUser{$user}{$nick} = 'nick';
		
	}

	foreach $line (@downloads) {
		my ($timestamp, $ip, $user, $nick, $file) = split(/\t/, $line);
		chop $file;
		
		# weird bug workaround
		next if ($user eq '');

		$dlsByUser{$user}{$file} = $timestamp;
		$nicksByUser{$user}{$nick} = 'nick';
	}
	
	
	# Count uploads per user & server wide
	foreach $user (keys %ulsByUser) {
		
		# weird bug workaround
		next if ($user eq '');
		
		foreach $file ( keys %{ $ulsByUser{$user} } ) {
			$ulCountByUser{$user}++;
			$serverStats{'Upload Count'}++;
		}
	}
	

	# Count downloads per user, file, & server wide
	foreach $user (keys %dlsByUser) {

		foreach $file ( keys %{ $dlsByUser{$user} } ) {
			$dlCountByUser{$user}++;
			$dlCountByFile{$file}++;
			$serverStats{'Download Count'}++;
		}
	}
	
	
	# fill in empty download and upload counts
	foreach $user (sort keys %nicksByUser) {
		$dlCountByUser{$user} = 0 if ($dlCountByUser{$user} eq '');
		$ulCountByUser{$user} = 0 if ($ulCountByUser{$user} eq '');
	}
	
	
	# server wide stats
	$serverStats{'Leach Ratio'} = $serverStats{'Upload Count'} / $serverStats{'Download Count'};
	$serverStats{'Leach Ratio'} = 100 - ($serverStats{'Leach Ratio'} * 100);
	
	# leach ratings
	foreach $user (keys %nicksByUser ) {
	
		# pay no attention! nothing to see here! move along!!!!!
		# nevermind... but it's SO tempting!!!
		#if ( $user eq 'riscit' ) {
		#	$leechRatesByUser{$user} = sprintf ("%.2f", -100);
		#	next;
		#}
		
	
		if ( ($dlCountByUser{$user} < 1) && ($ulCountByUser{$user} < 1) ) {
			
			# no uploads or downloads (who let mom online?)
			#
			# ok.. I'm an idiot... how would this person
			# get INTO the upload and download logs???
			# Whatever.. the code's here, let it be.
			#
			$leechRatesByUser{$user} = sprintf ("%.2f", 0);
			
			
		} elsif ($dlCountByUser{$user} < 1) {
		
			# no downloads, some uploads (what a saint, eh?)
			$leechRatesByUser{$user} = sprintf ("%.2f", -100);
		
		
		} elsif ($ulCountByUser{$user} < 1) {
		
			# no uploads, some downloads (looser!)
			$leechRatesByUser{$user} = sprintf ("%.2f", 100);
		
		
		} elsif ($ulCountByUser{$user} == $dlCountByUser{$user}) {
		
			# same uploads as downloads (holdin' his own)
			$leechRatesByUser{$user} = sprintf ("%.2f", 0);
			
			
		} elsif ($ulCountByUser{$user} > $dlCountByUser{$user}) {
			
			# more uploads than downloads (what a chum!)
			$rate = $dlCountByUser{$user} / $ulCountByUser{$user};
			$rate = 100 - ($rate * 100);
			$rate = 0 - $rate;
			$leechRatesByUser{$user} = sprintf ("%.2f", $rate);
			
			
		} else {
		 
			# more downloads than uploads (typical user)
			$rate = $ulCountByUser{$user} / $dlCountByUser{$user};
			$rate = 100 - ($rate * 100);
			$leechRatesByUser{$user} = sprintf ("%.2f", $rate);
		}
		
	}
	
	
	print "$BRReady.$BR$BR$BR" unless ($beQuiet);
	ClearScreen();
	
}

###############################################################

sub NonInteractiveOptions {


	# -fullreport
	if ($printFullReport) {
		
		$nonInterMode = '1';
		
		# this is gonna hurt...
		
		PrintServerWideStats();
		print "$BR$BR";
		PrintLeechRatiosSortedByRatio();
		print "$BR$BR";
		PrintLeechRatiosSortedByUser();
		print "$BR$BR$BR";
		
		foreach $user (sort keys %nicksByUser) {
			print "$user:$BR$BR";
			PrintGeneralStatsFor($user);
			print "$BR";
			PrintNicksUsedBy($user);
			print "$BR";
			PrintFilesUploadedBy($user);
			print "$BR";
			PrintFilesDownloadedBy($user);
			print "$BR$BR";
		}
		
		return 0;
	}
	
	
	# -stats
	if ($printStats) {
		
		if ($nonInterMode) {
			print "$BR$BR";
		} else {
			$nonInterMode = '1';
		}
		
		if ($selectAllUsers) {
			foreach $user (sort keys %nicksByUser) {
				PrintGeneralStatsFor($user);
			}
		} else {
			PrintGeneralStatsFor($userToCheck);
		}
	}
	
	
	
	# -serverstats
	if ($printServerStats) {
	
		if ($nonInterMode) {
			print "$BR$BR";
		} else {
			$nonInterMode = '1';
		}
		
		PrintServerWideStats();
	
	}
	
	
	# -leechbyratio
	if ($printLeechRatingsByRatio) {
	
		if ($nonInterMode) {
			print "$BR$BR";
		} else {
			$nonInterMode = '1';
		}
		
		PrintLeechRatiosSortedByRatio();
		
	}
	
	# -leechbyuser
	if ($printLeechRatingsByUser) {
	
		if ($nonInterMode) {
			print "$BR$BR";
		} else {
			$nonInterMode = '1';
		}
		
		PrintLeechRatiosSortedByUser();
		
	}
	
	# -nicks
	if ($printNicks) {
	
		if ($nonInterMode) {
			print "$BR$BR";
		} else {
			$nonInterMode = '1';
		}
		
		if ($selectAllUsers) {
			foreach $user (sort keys %nicksByUser) {
				PrintNicksUsedBy($user);
				print "$BR";
			}
		} else {
			PrintNicksUsedBy($userToCheck);
		}
	}
	
	
	# -downloads
	if ($printUsersDownloads) {
	
		if ($nonInterMode) {
			print "$BR$BR";
		} else {
			$nonInterMode = '1';
		}
		
		if ($selectAllUsers) {
			foreach $user (sort keys %nicksByUser) {
				PrintFilesDownloadedBy($user);
				print "$BR";
			}
		} else {
			PrintFilesDownloadedBy($userToCheck);
		}
	}
	
	
	# -uploads
	if ($printUsersUploads) {
	
		if ($nonInterMode) {
			print "$BR$BR";
		} else {
			$nonInterMode = '1';
		}
		
		if ($selectAllUsers) {
			foreach $user (sort keys %nicksByUser) {
				PrintFilesUploadedBy($user);
				print "$BR";
			}
		} else {
			PrintFilesUploadedBy($userToCheck);
		}
	}
	
	
	# -topdownloads
	if ($printTopDownloads) {
	
		if ($nonInterMode) {
			print "$BR$BR";
		} else {
			$nonInterMode = '1';
		}
		
		PrintTopXDownloads();
	}
	
	# -topdownloaders
	if ($printTopDownloaders) {
	
		if ($nonInterMode) {
			print "$BR$BR";
		} else {
			$nonInterMode = '1';
		}
		
		PrintTopXDownloaders();
		
	}
	
	# -topuploaders
	if ($printTopUploaders) {
	
		if ($nonInterMode) {
			print "$BR$BR";
		} else {
			$nonInterMode = '1';
		}
		
		PrintTopXUploaders();
		
	}
	
	# -worstleech
	if ($printWorstLeechRatios) {
	
		if ($nonInterMode) {
			print "$BR$BR";
		} else {
			$nonInterMode = '1';
		}
		
		PrintWorstXLeechRatios();
		
	}
	
	# -bestleech
	if ($printBestLeechRatios) {
	
		if ($nonInterMode) {
			print "$BR$BR";
		} else {
			$nonInterMode = '1';
		}
		
		PrintBestXLeechRatios();
		
	}

}

###############################################################

sub HTMLBarGraph {

	my ($col, $h, $w, $fillPercent) = @_;
	
	my $barWidth = $w * ( abs ($fillPercent / 100) );
	my $emptyBarWidth = $w - $barWidth;
	
	return qq|<TABLE CELLPADDING="0" CELLSPACING="1" BORDER="0" BGCOLOR="$col" HEIGHT="$h" WIDTH="$w"><TR><TD WIDTH="$barWidth" NOWRAP> </TD><TD WIDTH="$emptyBarWidth" NOWRAP BGCOLOR="#FFFFFF"> </TD></TR></TABLE>|;

	#return $fillPercent;

}


###############################################################

sub ConfirmToContinue {
	print "$BRPress Return To Continue...";
	my $trash = 0;
	system "stty cbreak </dev/tty >/dev/tty 2>&1";
    $trash = getc;
    system "stty -cbreak </dev/tty >/dev/tty 2>&1";
}

###############################################################

sub ClearScreen {
	# no screen clears in quiet mode
	return if ($beQuiet);
	
	system "clear";
}

###############################################################


#################################################################################
# Print any old hum drum file..                                                 #
# usage:                                                                        #
# PrintFile('filename.txt');                                                    #
# PrintFile($filename);                                                         #
#################################################################################
sub PrintFile {
  	local ( $fileName ) = @_ ;

	open(FILE, "<$fileName") || return;
	@file = <FILE>;
	close (FILE);

	foreach $line (@file) {
		print $line;
	}
}
